#define ROWS 5
#define COLS 5

#define ROW4 (!!(GPIOF->IDR & 1<<6))
#define ROW3 (!!(GPIOA->IDR & 1<<10))
#define ROW2 (!!(GPIOA->IDR & 1<<8))
#define ROW1 (!!(GPIOB->IDR & 1<<14))
#define ROW0 (!!(GPIOB->IDR & 1<<13))

#define COL4(X) (X)?(GPIOB->BSRR =1<<12):(GPIOB->BRR =1<<12)
#define COL3(X) (X)?(GPIOB->BSRR =1<<15):(GPIOB->BRR =1<<15)
#define COL2(X) (X)?(GPIOA->BSRR =1<<9) :(GPIOA->BRR =1<<9)
#define COL1(X) (X)?(GPIOA->BSRR =1<<11):(GPIOA->BRR =1<<11)
#define COL0(X) (X)?(GPIOF->BSRR =1<<7) :(GPIOF->BRR =1<<7)

#define LP  5
#define LH  50
#define LR  3


enum keyst {rls,prs,hold}btn[COLS][ROWS];


u8 scan_keys(enum keyst ks_input[COLS][ROWS])
{
 static u8 count[COLS][ROWS*3];
 u8 key_st[ROWS];
 u8 i;
 static s8 col=0;

 u8 ret_tmp_key_n=0xff;

 key_st[4] = ROW4;
 key_st[3] = ROW3;
 key_st[2] = ROW2;
 key_st[1] = ROW1;
 key_st[0] = ROW0;

 for(i=0;i<ROWS;i++)
 {
  if (!key_st[i])
  {
   if (count[col][i*3]>LP)
   {
    count[col][i*3]=0;

    if(btn[col][i]==rls)
    {
     btn[col][i]=prs;
     ret_tmp_key_n = col + i*COLS;
    }

    if(count[col][i*3+1]>LH)
    {
     btn[col][i]=hold;
     count[col][i*3+1]=0;
    }
    else
     count[col][i*3+1]++;
   }
   else
    count[col][i*3]++;

   count[col][i*3+2]=LR;
  }
  else
  {
   if(count[col][i*3+2])
    count[col][i*3+2]--;
   else
   {
    count[col][i*3]=count[col][i*3+1]=0;
    btn[col][i]=rls;
   }
  }
 }

 if(col==0)
 {
  COL0(1);
  COL1(0);
  COL2(1);
  COL3(1);
  COL4(1);
 }
 else if(col==1)
 {
  COL0(1);
  COL1(1);
  COL2(0);
  COL3(1);
  COL4(1);
 }
 else if(col==2)
 {
  COL0(1);
  COL1(1);
  COL2(1);
  COL3(0);
  COL4(1);
 }
 else if(col==3)
 {
  COL0(1);
  COL1(1);
  COL2(1);
  COL3(1);
  COL4(0);
 }
 else
 {
  COL0(0);
  COL1(1);
  COL2(1);
  COL3(1);
  COL4(1);

  col=-1;
 }
 col++;

 return ret_tmp_key_n;
}
